
var dm_gDownloadManager;
var dmActiveDownloads  = [];
var localDownloadLabel = "Downloads";
window.addEventListener("load", dminit, true);
var oldListener = null;
var dmLastComputedMean = 0;
const interval = 500;
var lastUpdate = -500;
var dmQueuedDownloads  = [];

function dmNoOp()
{
  alert('Hello, world');
}

function toggleDownloadMgr(open, close)
{
  var ww = Components.classes["@mozilla.org/embedcomp/window-watcher;1"]
                     .getService(Components.interfaces.nsIWindowWatcher);

  if (window != ww.activeWindow) return 1;

//  if (window.arguments) alert(window.arguments[0]);

  var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].
                           getService(Components.interfaces.nsIPrefService).getBranch("");
  var winType = preferencesService.getIntPref("extensions.downloadmgr.windowType");

  if (winType == 1)
  {
    // Open Download Manager as a side bar
    if (open && close)
      toggleSidebar('viewDMSidebar');
    else if (open)
      toggleSidebar('viewDMSidebar',true);
  }
  else if (winType == 2)
  {
    // Open Download Manager as a tab
    var numTabs = gBrowser.mTabContainer.childNodes.length;
    var index = 0;
    var oldTab = getBrowser().selectedTab;
    var downTab = null;

    // search tabs to see if one of them is the download tab.
    for (index = 0; index < numTabs; ++index)
    {
      var tempTab = gBrowser.mTabContainer.childNodes[index];
      var dmtPanel= document.getElementById(tempTab.linkedPanel);

      if (dmtPanel.firstChild.currentURI.spec ==
          'chrome://mozapps/content/downloads/downloads.xul')
      {
        downTab = tempTab;
        break;
      }
    }

    if (downTab)
    {
      // Download tab is already open. Close it if it's the current tab or,
      // make it the current tab if it isn't.
      if (close)
      {
        if (downTab == oldTab)
        {
          BrowserCloseTabOrWindow();
        }
        else
          getBrowser().selectedTab = downTab;
      }
    }
    else
    {
      // No download tab is open, create one.
      var downTab = gBrowser.addTab('chrome://mozapps/content/downloads/downloads.xul');
      updateDMTab();

      if (!gPrefService.getBoolPref("extensions.downloadmgr.loadTabInBackground"))
        getBrowser().selectedTab = downTab;
      else
        getBrowser().selectedTab = oldTab;

//      setTimeout('setListener()',500);
    }
  }
  else
  {
    // Open Download Manager as a window
    if (open)
    {
      toOpenWindowByType('Download:Manager',
                         'chrome://mozapps/content/downloads/downloads.xul',
                         'chrome,dialog=no,resizable');
    }
  }

  return 0;
}

// Updates the label and icon of the Download Manager tab
function updateDMTab()
{
  var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
  var showIcon = preferencesService.getBoolPref("extensions.downloadmgr.tabBusyIcon");

  var numTabs = gBrowser.mTabContainer.childNodes.length;
  var index = 0;

  var tempTab = null;
  var dmTab = null;
  while (index < numTabs) {
    tempTab = gBrowser.mTabContainer.childNodes[index];
    var dmtPanel = document.getElementById(tempTab.linkedPanel);

    if (dmtPanel.firstChild.currentURI.spec ==
        'chrome://mozapps/content/downloads/downloads.xul')
    {
      dmTab = tempTab;
      break;
    }
    else index = index+1;
  }
  if (dmTab) {
    if (dmActiveDownloads.length == 0) {
      dmLastComputedMean = 0;
      dmTab.label = localDownloadLabel;
      dmTab.removeAttribute('dl_active');
    }
    else {
      if (showIcon) dmTab.setAttribute('dl_active', 'true');
//      if (dmActiveDownloads.length == 1) {
//        if (dmLastComputedMean <= 0) dmTab.label = "Downloading 1 file - " + localDownloadLabel;
//        else dmTab.label = dmLastComputedMean + "% of 1 file - " + localDownloadLabel;
//      }
//      else {
//        if (dmLastComputedMean <= 0) dmTab.label = "Downloading " + dmActiveDownloads.length + " files - " + localDownloadLabel;
//        else dmTab.label = dmLastComputedMean + "% of " + dmActiveDownloads.length + " files - " + localDownloadLabel;
//      }
    }
  }
}

// Clean-up function called when a download is finished
function dmCompleted(aDownload)
{
  try {
    // Remove the download from our book-keeping list and if the count
    // falls to zero, update the title here, since we won't be getting
    // any more progress notifications in which to do it.
    for (var i = 0; i < dmActiveDownloads.length; ++i) {
      if (dmActiveDownloads[i] == aDownload || dmActiveDownloads[i] == aDownload.source) {
        dmActiveDownloads.splice(i, 1);
        break;
      }
    }
  }
  catch (e) {
  }
  updateDMTab();
}

function dmWindowClose(count)
{
  if (count > 5) return;
  var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
  var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
  var dmWindow = windowManagerInterface.getMostRecentWindow("Download:Manager");

  if (!dmWindow) setTimeout('dmWindowClose(' + (count+1) + ')',100);
  else dmWindow.close();
}

// Automatically close the download manager
function dmAutoClose()
{
  // If files are still downloading, don't close the DM
  if (dmActiveDownloads.length > 0) return;
  // or if the user opened the DM, don't automatically close it
  //else if (window.opener && window.opener.location.href != window.location.href) return;

  var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
  var winType = preferencesService.getIntPref("extensions.downloadmgr.windowType");

  if (winType == 1)
  {
    // Close Download Manager in a side bar
    var title = localDownloadLabel;
    var sidebarTitle = document.getElementById("sidebar-title");
    if (sidebarTitle.value == title) toggleSidebar('viewDMSidebar', false);
  }
  else if (winType == 2)
  {
    // Close Download Manager in a tab
    var numTabs = gBrowser.mTabContainer.childNodes.length;
    var index = 0;
    var oldTab = getBrowser().selectedTab;

    // Check if current tab is the DM
    if (getWebNavigation().currentURI.spec == "chrome://mozapps/content/downloads/downloads.xul") {
      if (!gPrefService.getBoolPref("extensions.downloadmgr.loadTabInBackground"))
        BrowserCloseTabOrWindow();
      return;
    }

    // Find and close the DM tab (if one is open)
    while (index < numTabs) {
      var tempTab = gBrowser.mTabContainer.childNodes[index];
      var dmtPanel = document.getElementById(tempTab.linkedPanel);

      if (dmtPanel.firstChild.currentURI.spec ==
          'chrome://mozapps/content/downloads/downloads.xul')
      {
        getBrowser().selectedTab = tempTab;
        BrowserCloseTabOrWindow();
        getBrowser().selectedTab = oldTab;
        return;
      }
      else index = index+1;
    }
  }
  else
  {
    // Close Download Manager in a separate window
    dmWindowClose(0);
  }
}

function dmDelayedOpen()
{
  if (dmActiveDownloads.length > 0) {
    if(toggleDownloadMgr(true,false)) setTimeout('toggleDownloadMgr(true,false)',500);
  }
}

var dmDownloadObserver = {
  observe: function (aSubject, aTopic, aState)
  {
    var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
    switch (aTopic) {
    case "dl-done":
      var dl = aSubject.QueryInterface(Components.interfaces.nsIDownload);
      dmCompleted(dl);

      var maxConcurrentDownloads = pref.getIntPref("extensions.downloadmgr.maxConcurrentDownloads");
      if (dmQueuedDownloads.length > 0 && dmActiveDownloads.length < maxConcurrentDownloads) {
        dmStartQueuedDownload();
      }
      else {
      try {
          var close = pref.getBoolPref("extensions.downloadmgr.closeWhenDone");
      } catch (e) {}

      if (close != false) dmAutoClose();
      }
      break;
    case "dl-failed":
    case "dl-cancel":
      var dl = aSubject.QueryInterface(Components.interfaces.nsIDownload);
      dmCompleted(dl);

      var maxConcurrentDownloads = pref.getIntPref("extensions.downloadmgr.maxConcurrentDownloads");
      if (dmQueuedDownloads.length > 0 && dmActiveDownloads.length < maxConcurrentDownloads)
        dmStartQueuedDownload();
      break;
    case "dl-start":
      // Add this download to the percentage average tally
      var dl = aSubject.QueryInterface(Components.interfaces.nsIDownload);
      dmActiveDownloads.push(dl);
      var show = false;
      try {
        var show = pref.getBoolPref("extensions.downloadmgr.showWhenStarting");
      } catch (e) {show = false;}

      var delay = pref.getIntPref("browser.download.manager.openDelay");
      if (show != false)
      {
        if (delay == 0)
          dmDelayedOpen();
        else
          setTimeout('dmDelayedOpen()',delay);
      }
      updateDMTab();
      break;
    }
  }
};

// Called when a link is added to download queue
function dmqueue(link)
{
  var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

  var maxConcurrentDownloads = pref.getIntPref("extensions.downloadmgr.maxConcurrentDownloads");
  if (dmActiveDownloads.length < maxConcurrentDownloads) {
    saveURL( link, null, null, true, true );
  }
  else {
    internalQueue(link, null, null, null, null, true, null, null, null, true);
  }
}

// Only show the "Add to Download Queue..." menu item when the link is saveable
function dmqueueToggle(contextMenu)
{
  var show = contextMenu.onSaveableLink;

  var item = document.getElementById("context-queuelink");
  if (item) item.hidden = !show;
}

// Start downloading a given URL
function dmStartQueuedDownload() {
  try {
    var src = dmQueuedDownloads[0];
    var trg = dmQueuedDownloads[1];
    var persist = dmQueuedDownloads[2];
    dmQueuedDownloads.splice(0, 3);

    persist.saveURI(src, null, null, null, null, trg);
    dmActiveDownloads.push(src);

    updateDMTab();
    } catch (e) { }
}

function dminit()
{
  window.removeEventListener("load", dminit, true);

  // Set the download manager listener (used for updating DM Tab %'s)
  //const dm_dlmgrContractID = "@mozilla.org/download-manager;1";
  //const dm_dlmgrIID = Components.interfaces.nsIDownloadManager;
  //dm_gDownloadManager = Components.classes[dm_dlmgrContractID].getService(dm_dlmgrIID);
  //dm_gDownloadManager.listener = dmListener;

  localDownloadLabel = document.getElementById("viewDMSidebar").getAttribute("label");

  // Handlers for events generated by the Download Manager (download events)
  var observerService = Components.classes["@mozilla.org/observer-service;1"]
                                  .getService(Components.interfaces.nsIObserverService);
  observerService.addObserver(dmDownloadObserver, "dl-done",   false);
  observerService.addObserver(dmDownloadObserver, "dl-cancel", false);
  observerService.addObserver(dmDownloadObserver, "dl-failed", false);
  observerService.addObserver(dmDownloadObserver, "dl-start",  false);
  //observerService.addObserver(dmDownloadObserver, "dl-progress",  false);
  //observerService.addObserver(dmDownloadObserver, "xpinstall-download-started", false);
  //observerService.addObserver(dmDownloadObserver, "xpinstall-dialog-close",     false);

  var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
  var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
  try {
    pref.setBoolPref("browser.download.manager.showWhenStarting", false);
    pref.setBoolPref("browser.download.manager.closeWhenDone", false);
  } catch (e) {}
}

function dmexit(aEvent)
{
  var observerService = Components.classes["@mozilla.org/observer-service;1"]
                                  .getService(Components.interfaces.nsIObserverService);
  observerService.removeObserver(dmDownloadObserver, "dl-done");
  observerService.removeObserver(dmDownloadObserver, "dl-cancel");
  observerService.removeObserver(dmDownloadObserver, "dl-failed");
  observerService.removeObserver(dmDownloadObserver, "dl-start");
  //observerService.removeObserver(dmDownloadObserver, "xpinstall-download-started");
  //observerService.removeObserver(dmDownloadObserver, "xpinstall-dialog-close");
}

function internalQueue(aURL, aDocument, aDefaultFileName, aContentDisposition,
                      aContentType, aShouldBypassCache, aFilePickerTitleKey,
                      aChosenData, aReferrer, aSkipPrompt)
{
  if (aSkipPrompt == undefined)
    aSkipPrompt = false;

  // Note: aDocument == null when this code is used by save-link-as...
  var saveMode = GetSaveModeForContentType(aContentType);
  var isDocument = aDocument != null && saveMode != SAVEMODE_FILEONLY;
  var saveAsType = kSaveAsType_Complete;

  var file, fileURL;
  // Find the URI object for aURL and the FileName/Extension to use when saving.
  // FileName/Extension will be ignored if aChosenData supplied.
  var fileInfo = new FileInfo(aDefaultFileName);
  if (aChosenData)
    file = aChosenData.file;
  else {
    initFileInfo(fileInfo, aURL, aDocument, aContentType, aContentDisposition);
    var fpParams = {
      fpTitleKey: aFilePickerTitleKey,
      isDocument: isDocument,
      fileInfo: fileInfo,
      contentType: aContentType,
      saveMode: saveMode,
      saveAsType: saveAsType,
      file: file,
      fileURL: fileURL
    };

    if (!getTargetFile(fpParams, aSkipPrompt))
      // If the method returned false this is because the user cancelled from
      // the save file picker dialog.
      return;

    saveAsType = fpParams.saveAsType;
    saveMode = fpParams.saveMode;
    file = fpParams.file;
    fileURL = fpParams.fileURL;
  }

  if (!fileURL)
    fileURL = makeFileURI(file);

  // XXX We depend on the following holding true in appendFiltersForContentType():
  // If we should save as a complete page, the saveAsType is kSaveAsType_Complete.
  // If we should save as text, the saveAsType is kSaveAsType_Text.
  var useSaveDocument = isDocument &&
                        (((saveMode & SAVEMODE_COMPLETE_DOM) && (saveAsType == kSaveAsType_Complete)) ||
                         ((saveMode & SAVEMODE_COMPLETE_TEXT) && (saveAsType == kSaveAsType_Text)));
  // If we're saving a document, and are saving either in complete mode or
  // as converted text, pass the document to the web browser persist component.
  // If we're just saving the HTML (second option in the list), send only the URI.
  var source = useSaveDocument ? aDocument : fileInfo.uri;
  var persistArgs = {
    source      : source,
    contentType : (!aChosenData && useSaveDocument &&
                   saveAsType == kSaveAsType_Text) ?
                   "text/plain" : aContentType,
    target      : fileURL,
    postData    : isDocument ? getPostData() : null,
    bypassCache : aShouldBypassCache
  };

  var persist = makeWebBrowserPersist();

  // Calculate persist flags.
  const nsIWBP = Components.interfaces.nsIWebBrowserPersist;
  const flags = nsIWBP.PERSIST_FLAGS_REPLACE_EXISTING_FILES;
  if (aShouldBypassCache)
    persist.persistFlags = flags | nsIWBP.PERSIST_FLAGS_BYPASS_CACHE;
  else
    persist.persistFlags = flags | nsIWBP.PERSIST_FLAGS_FROM_CACHE;

  // Leave it to WebBrowserPersist to discover the encoding type (or lack thereof):
  persist.persistFlags |= nsIWBP.PERSIST_FLAGS_AUTODETECT_APPLY_CONVERSION;

  // Create download and initiate it (below)
  var tr = Components.classes["@mozilla.org/transfer;1"].createInstance(Components.interfaces.nsITransfer);

  if (useSaveDocument) {
    // Saving a Document, not a URI:
    var filesFolder = null;
    if (persistArgs.contentType != "text/plain") {
      // Create the local directory into which to save associated files.
      filesFolder = file.clone();

      var nameWithoutExtension = filesFolder.leafName.replace(/\.[^.]*$/, "");
      var filesFolderLeafName = getStringBundle().formatStringFromName("filesFolder",
                                                                       [nameWithoutExtension],
                                                                       1);

      filesFolder.leafName = filesFolderLeafName;
    }

    var encodingFlags = 0;
    if (persistArgs.contentType == "text/plain") {
      encodingFlags |= nsIWBP.ENCODE_FLAGS_FORMATTED;
      encodingFlags |= nsIWBP.ENCODE_FLAGS_ABSOLUTE_LINKS;
      encodingFlags |= nsIWBP.ENCODE_FLAGS_NOFRAMES_CONTENT;
    }
    else {
      encodingFlags |= nsIWBP.ENCODE_FLAGS_ENCODE_BASIC_ENTITIES;
    }

    const kWrapColumn = 80;
    tr.init((aChosenData ? aChosenData.uri : fileInfo.uri),
            persistArgs.target, "", null, null, null, persist);
    //persist.progressListener = tr;
    //persist.saveDocument(persistArgs.source, persistArgs.target, filesFolder,
    //                     persistArgs.contentType, encodingFlags, kWrapColumn);

    try {
      // Remove the download from our book-keeping list and if the count
      // falls to zero, update the title here, since we won't be getting
      // any more progress notifications in which to do it.
      dmQueuedDownloads.push((aChosenData ? aChosenData.uri : fileInfo.uri));
      dmQueuedDownloads.push(persistArgs.target);
      dmQueuedDownloads.push(persist);

      for (var i = 0; i < dmActiveDownloads.length; ++i) {
        if (dmActiveDownloads[i].source == (aChosenData ? aChosenData.uri : fileInfo.uri)) {
          dmActiveDownloads.splice(i, 1);
          break;
        }
      }
    } catch (e) { }
    updateDMTab();
  } else {
    tr.init((aChosenData ? aChosenData.uri : source),
            persistArgs.target, "", null, null, null, persist);
    persist.progressListener = tr;
    //persist.saveURI((aChosenData ? aChosenData.uri : source),
    //                null, aReferrer, persistArgs.postData, null,
    //                persistArgs.target);

    try {
      // Remove the download from our book-keeping list and if the count
      // falls to zero, update the title here, since we won't be getting
      // any more progress notifications in which to do it.
      dmQueuedDownloads.push((aChosenData ? aChosenData.uri : source));
      dmQueuedDownloads.push(persistArgs.target);
      dmQueuedDownloads.push(persist);

      for (var i = 0; i < dmActiveDownloads.length; ++i) {
        if (dmActiveDownloads[i].source == (aChosenData ? aChosenData.uri : source)) {
          dmActiveDownloads.splice(i, 1);
          break;
        }
      }
    } catch (e) { }
    updateDMTab();
  }
}

