var prevSelectedCount = 0;
var prevSelectedItem = null;
var dmDownloadManager = null;
var dmDownloadListener = null;
var dmSavedDownloadsView = null;
var dmStartButtonLabel = "";
var dmLaunchButtonLabel = "";
var dmShowButtonLabel = "";
var dmCleanUpButtonLabel = "";
var dmCleanUpSepFlex = 0;
var dmWindowType = 0;

////////////////////////////////////////////////////////////////////////////////
// This event listener is called whenever the selection changes for the
// download list. Need to selectively enable/disable the command bar buttons
// and fill in the infoBar data.
function onDownloadSelect(aEvent)
{
  var dlState = 0;

  if ((gDownloadsView.selectedCount != prevSelectedCount) ||
      (gDownloadsView.selectedItem != prevSelectedItem))
  {
    prevSelectedCount = gDownloadsView.selectedCount;
    prevSelectedItem = gDownloadsView.selectedItem;

    if ((gDownloadsView.selectedCount > 0) && gDownloadsView.selectedItem)
    {
      dlState = parseInt(gDownloadsView.selectedItem.getAttribute("state"));
    }
    updateToolInfoBar(dlState);
  }
}

////////////////////////////////////////////////////////////////////////////////
// Updates all the toolbar and infobar parts which change when different
// downloads are selected or the selected changes state.
function updateToolInfoBar(dlState)
{
  if ((gDownloadsView.selectedCount > 0) && gDownloadsView.selectedItem)
  {
    var fileExists = false;
    var from = gDownloadsView.selectedItem.getAttribute("uri");
    var to = gDownloadsView.selectedItem.getAttribute("path");
    var date = new Date(parseInt(gDownloadsView.selectedItem.getAttribute("endTime")));
    var currBytes = parseInt(gDownloadsView.selectedItem.getAttribute("currBytes"));
    var maxBytes = parseInt(gDownloadsView.selectedItem.getAttribute("maxBytes"));
    var transfered = bytesToTransfered(currBytes, maxBytes);

    try {
      var fileName = gDownloadsView.selectedItem.getAttribute("file")
      var fileObj = getLocalFileFromNativePathOrUrl(fileName);
      fileExists = fileObj.exists();
    } catch (e) {
      fileExists = false
    }

    // Fill in the infoBar according to the selected download.
    document.getElementById("dmDownloadFrom").value = from;
    document.getElementById("dmDownloadTo").value = to;
    document.getElementById("dmDownloadDate").value = date.toLocaleString();
    document.getElementById("dmDownloadTransferred").value = transfered;
    document.getElementById("dmDownloadDateSB").value = date.toLocaleString();
    document.getElementById("dmDownloadTransferredSB").value = transfered;
    document.getElementById("dmDownloadFrom2").value = from;
    document.getElementById("dmDownloadTo2").value = to;
    document.getElementById("dmDownloadDate2").value = date.toLocaleString();
    document.getElementById("dmDownloadTransferred2").value = transfered;
    document.getElementById("dmDownloadDateSB2").value = date.toLocaleString();
    document.getElementById("dmDownloadTransferredSB2").value = transfered;

    if (dlState < 0)
      dlState = 0;

    // Enable buttons for the selected download according to the state of
    // that download.
    switch (dlState) {
    case 0:  // Downloading
      document.getElementById("dmStartButton").disabled = true;
      document.getElementById("dmStartButton2").disabled = true;
      document.getElementById("dmLaunchButton").disabled = true;
      document.getElementById("dmLaunchButton2").disabled = true;
      document.getElementById("dmShowButton").disabled = true;
      document.getElementById("dmShowButton2").disabled = true;
      document.getElementById("dmCleanUpButton").disabled = true;
      document.getElementById("dmCleanUpButton2").disabled = true;
      break;
    case 1:  // Done
      document.getElementById("dmStartButton").disabled = true;
      document.getElementById("dmStartButton2").disabled = true;
      if (fileExists)
      {
        document.getElementById("dmLaunchButton").disabled = false;
        document.getElementById("dmLaunchButton2").disabled = false;
        document.getElementById("dmShowButton").disabled = false;
        document.getElementById("dmShowButton2").disabled = false;
      }
      else
      {
        document.getElementById("dmLaunchButton").disabled = true;
        document.getElementById("dmLaunchButton2").disabled = true;
        document.getElementById("dmShowButton").disabled = true;
        document.getElementById("dmShowButton2").disabled = true;
      }
      document.getElementById("dmCleanUpButton").disabled = false;
      document.getElementById("dmCleanUpButton2").disabled = false;
      break;
    case 2:  // Failed
    case 3:  // Canceled
      document.getElementById("dmStartButton").disabled = false;
      document.getElementById("dmStartButton2").disabled = false;
      document.getElementById("dmLaunchButton").disabled = true;
      document.getElementById("dmLaunchButton2").disabled = true;
      document.getElementById("dmShowButton").disabled = true;
      document.getElementById("dmShowButton2").disabled = true;
      document.getElementById("dmCleanUpButton").disabled = false;
      document.getElementById("dmCleanUpButton2").disabled = false;
      break;
    case 4:  // Paused
      document.getElementById("dmStartButton").disabled = true;
      document.getElementById("dmStartButton2").disabled = true;
      document.getElementById("dmLaunchButton").disabled = true;
      document.getElementById("dmLaunchButton2").disabled = true;
      document.getElementById("dmShowButton").disabled = true;
      document.getElementById("dmShowButton2").disabled = true;
      document.getElementById("dmCleanUpButton").disabled = false;
      document.getElementById("dmCleanUpButton2").disabled = false;
      break;
    case 7:  // Install Done
      document.getElementById("dmStartButton").disabled = true;
      document.getElementById("dmStartButton2").disabled = true;
      document.getElementById("dmLaunchButton").disabled = true;
      document.getElementById("dmLaunchButton2").disabled = true;
      document.getElementById("dmShowButton").disabled = true;
      document.getElementById("dmShowButton2").disabled = true;
      document.getElementById("dmCleanUpButton").disabled = true;
      document.getElementById("dmCleanUpButton2").disabled = true;
      break;
    default:
      document.getElementById("dmStartButton").disabled = true;
      document.getElementById("dmStartButton2").disabled = true;
      document.getElementById("dmLaunchButton").disabled = true;
      document.getElementById("dmLaunchButton2").disabled = true;
      document.getElementById("dmShowButton").disabled = true;
      document.getElementById("dmShowButton2").disabled = true;
      document.getElementById("dmCleanUpButton").disabled = true;
      document.getElementById("dmCleanUpButton2").disabled = true;
      break;
    }
  }
  else
  {
    // No download selected, disable everything.
    document.getElementById("dmStartButton").disabled = true;
    document.getElementById("dmStartButton2").disabled = true;
    document.getElementById("dmLaunchButton").disabled = true;
    document.getElementById("dmLaunchButton2").disabled = true;
    document.getElementById("dmShowButton").disabled = true;
    document.getElementById("dmShowButton2").disabled = true;
    document.getElementById("dmCleanUpButton").disabled = true;
    document.getElementById("dmCleanUpButton2").disabled = true;
    document.getElementById("dmDownloadFrom").value = "";
    document.getElementById("dmDownloadTo").value = "";
    document.getElementById("dmDownloadDate").value = "";
    document.getElementById("dmDownloadTransferred").value = "";
    document.getElementById("dmDownloadDateSB").value = "";
    document.getElementById("dmDownloadTransferredSB").value = "";
    document.getElementById("dmDownloadFrom2").value = "";
    document.getElementById("dmDownloadTo2").value = "";
    document.getElementById("dmDownloadDate2").value = "";
    document.getElementById("dmDownloadTransferred2").value = "";
    document.getElementById("dmDownloadDateSB2").value = "";
    document.getElementById("dmDownloadTransferredSB2").value = "";
  }
}

////////////////////////////////////////////////////////////////////////////////
// gDownloadsView changes on occasion, for example whenever buildDownloadList()
// is called. That results in the event listener no longer generating select
// events. Need to remove the listener for the old view and and add one for the
// new view. This is only done if gDownloadsView changes.
function onDownloadClick(aEvent)
{
  if (dmSavedDownloadsView != gDownloadsView)
  {
    dmSavedDownloadsView.removeEventListener("select", onDownloadSelect, false);
    gDownloadsView.addEventListener("select", onDownloadSelect, false);
    onDownloadSelect(aEvent);
  }
}

////////////////////////////////////////////////////////////////////////////////
// This observer is called whenever preference in the "extensions.downloadmgr."
// branch changes. 
let dmtPrefObserver = {
  observe: function (aSubject, aTopic, aData)
  {
    try {
      if (aTopic == "nsPref:changed")
      {
        if (aData == "extensions.downloadmgr.windowType")
        {
          // Need to close window with old type and then open with new type.
          // Unfortunately I don't think this can be done here.
          //alert("dmt observe:");
        }
        else
        {
          // Just redraw existing window.
          dmtHideByPreference();
        }
      }
    } catch (e) {}
  }
};

////////////////////////////////////////////////////////////////////////////////
// Hides and shows window elements depending on the preferences set by the user.
// Can be called at startup or whenever the preferences are changed.
function dmtHideByPreference()
{
  var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].
                           getService(Components.interfaces.nsIPrefService).getBranch("");

  try {
    // First unhide everything to match original setting in .xul.
//    document.getElementById("dmDownloadDateTrans").hidden = false;
//    document.getElementById("dmDownloadDateTrans2").hidden = false;
//    document.getElementById("dmDownloadTransferredTitleSB").hidden = false;
    document.getElementById("dmDownloadDateSB").hidden = false;
//    document.getElementById("dmDownloadTransferredSB").hidden = false;
//    document.getElementById("dmDownloadTransferredTitleSB2").hidden = false;
    document.getElementById("dmDownloadDateSB2").hidden = false;
//    document.getElementById("dmDownloadTransferredSB2").hidden = false;
    document.getElementById("topToolBar").hidden = false;
    document.getElementById("dmDownloadInfoBar").hidden = false;
    document.getElementById("bottomToolBar").hidden = false;
    document.getElementById("dmDownloadInfoBar2").hidden = false;
    document.getElementById("dmStartButton").hidden = false;
    document.getElementById("dmStartButton2").hidden = false;
    document.getElementById("dmStartSep").hidden = false;
    document.getElementById("dmStartSep2").hidden = false;
    document.getElementById("dmLaunchButton").hidden = false;
    document.getElementById("dmLaunchButton2").hidden = false;
    document.getElementById("dmLaunchSep").hidden = false;
    document.getElementById("dmLaunchSep2").hidden = false;
    document.getElementById("dmShowButton").hidden = false;
    document.getElementById("dmShowButton2").hidden = false;
    document.getElementById("dmShowSep").hidden = false;
    document.getElementById("dmShowSep2").hidden = false;
    document.getElementById("dmCleanUpButton").hidden = false;
    document.getElementById("dmCleanUpButton2").hidden = false;
    document.getElementById("dmOptionsButton").hidden = false;
    document.getElementById("dmOptionsButton2").hidden = false;
    document.getElementById("dmDownloadInfoBar").hidden = false;
    document.getElementById("dmDownloadInfoBar2").hidden = false;

    // Always hide the tranferred field. Will probably delete later. The built
    // in Download Manager in Firefox 3.0 displays this just fine.
    document.getElementById("dmDownloadDateTrans").hidden = true;
    document.getElementById("dmDownloadDateTrans2").hidden = true;
    document.getElementById("dmDownloadTransferredTitleSB").hidden = true;
    document.getElementById("dmDownloadTransferredSB").hidden = true;
    document.getElementById("dmDownloadTransferredTitleSB2").hidden = true;
    document.getElementById("dmDownloadTransferredSB2").hidden = true;

  } catch (e) {}

  try {
    if (dmWindowType == 1)
    {
      // Download Manager is a side bar
      document.getElementById("dmStartButton").removeAttribute("label");
      document.getElementById("dmStartButton2").removeAttribute("label");
      document.getElementById("dmLaunchButton").removeAttribute("label");
      document.getElementById("dmLaunchButton2").removeAttribute("label");
      document.getElementById("dmShowButton").removeAttribute("label");
      document.getElementById("dmShowButton2").removeAttribute("label");
      document.getElementById("dmCleanUpButton").removeAttribute("label");
      document.getElementById("dmCleanUpButton2").removeAttribute("label");
      document.getElementById("dmCleanUpSep").flex = 0;
      document.getElementById("dmCleanUpSep2").flex = 0;
      document.getElementById("searchSpacerSB").hidden = false;

//      document.getElementById("dmDownloadDateTrans").hidden = true;
//      document.getElementById("dmDownloadDateTrans2").hidden = true;
    }
    else if (dmWindowType == 2)
    {
      // Download Manager is a tab
      document.getElementById("dmStartButton").label = dmStartButtonLabel;
      document.getElementById("dmStartButton2").label = dmStartButtonLabel;
      document.getElementById("dmLaunchButton").label = dmLaunchButtonLabel;
      document.getElementById("dmLaunchButton2").label = dmLaunchButtonLabel;
      document.getElementById("dmShowButton").label = dmShowButtonLabel;
      document.getElementById("dmShowButton2").label = dmShowButtonLabel;
      document.getElementById("dmCleanUpButton").label = dmCleanUpButtonLabel;
      document.getElementById("dmCleanUpButton2").label = dmCleanUpButtonLabel;
      document.getElementById("dmCleanUpSep").flex = dmCleanUpSepFlex;
      document.getElementById("dmCleanUpSep2").flex = dmCleanUpSepFlex;
      document.getElementById("searchSpacerSB").hidden = true;

//      document.getElementById("dmDownloadTransferredTitleSB").hidden = true;
//      document.getElementById("dmDownloadDateSB").hidden = true;
//      document.getElementById("dmDownloadTransferredSB").hidden = true;
//      document.getElementById("dmDownloadTransferredTitleSB2").hidden = true;
//      document.getElementById("dmDownloadDateSB2").hidden = true;
//      document.getElementById("dmDownloadTransferredSB2").hidden = true;
    }
    else
    {
      // Download Manager is a window
      document.getElementById("dmStartButton").label = dmStartButtonLabel;
      document.getElementById("dmStartButton2").label = dmStartButtonLabel;
      document.getElementById("dmLaunchButton").label = dmLaunchButtonLabel;
      document.getElementById("dmLaunchButton2").label = dmLaunchButtonLabel;
      document.getElementById("dmShowButton").label = dmShowButtonLabel;
      document.getElementById("dmShowButton2").label = dmShowButtonLabel;
      document.getElementById("dmCleanUpButton").label = dmCleanUpButtonLabel;
      document.getElementById("dmCleanUpButton2").label = dmCleanUpButtonLabel;
      document.getElementById("dmCleanUpSep").flex = dmCleanUpSepFlex;
      document.getElementById("dmCleanUpSep2").flex = dmCleanUpSepFlex;
      document.getElementById("searchSpacerSB").hidden = true;

//      document.getElementById("dmDownloadTransferredTitleSB").hidden = true;
//      document.getElementById("dmDownloadDateSB").hidden = true;
//      document.getElementById("dmDownloadTransferredSB").hidden = true;
//      document.getElementById("dmDownloadTransferredTitleSB2").hidden = true;
//      document.getElementById("dmDownloadDateSB2").hidden = true;
//      document.getElementById("dmDownloadTransferredSB2").hidden = true;
    }

    var bottom = preferencesService.getBoolPref("extensions.downloadmgr.bottomToolBar");
    if (bottom)
    {
      document.getElementById("topToolBar").hidden = true;
      document.getElementById("dmDownloadInfoBar").hidden = true;
    }
    else
    {
      document.getElementById("bottomToolBar").hidden = true;
      document.getElementById("dmDownloadInfoBar2").hidden = true;
    }

    var dlButton = preferencesService.getBoolPref("extensions.downloadmgr.buttonDownload");
    if (!dlButton) {
      document.getElementById("dmStartButton").hidden = true;
      document.getElementById("dmStartButton2").hidden = true;
      document.getElementById("dmStartSep").hidden = true;
      document.getElementById("dmStartSep2").hidden = true;
    }

    var launchButton = preferencesService.getBoolPref("extensions.downloadmgr.buttonLaunch");
    if (!launchButton) {
      document.getElementById("dmLaunchButton").hidden = true;
      document.getElementById("dmLaunchButton2").hidden = true;
      document.getElementById("dmLaunchSep").hidden = true;
      document.getElementById("dmLaunchSep2").hidden = true;
    }

    var showButton = preferencesService.getBoolPref("extensions.downloadmgr.buttonShow");
    if (!showButton) {
      document.getElementById("dmShowButton").hidden = true;
      document.getElementById("dmShowButton2").hidden = true;
      document.getElementById("dmShowSep").hidden = true;
      document.getElementById("dmShowSep2").hidden = true;
    }

    var cleanButton = preferencesService.getBoolPref("extensions.downloadmgr.buttonClean");
    if (!cleanButton) {
      document.getElementById("dmCleanUpButton").hidden = true;
      document.getElementById("dmCleanUpButton2").hidden = true;
    }

    var optionsButton = preferencesService.getBoolPref("extensions.downloadmgr.buttonOptions");
    if (!optionsButton) {
      document.getElementById("dmOptionsButton").hidden = true;
      document.getElementById("dmOptionsButton2").hidden = true;
    }

    var showInfoBar = preferencesService.getBoolPref("extensions.downloadmgr.showInfoBar");
    if (!showInfoBar) {
      document.getElementById("dmDownloadInfoBar").hidden = true;
      document.getElementById("dmDownloadInfoBar2").hidden = true;
    }
  } catch (e) {}
}

////////////////////////////////////////////////////////////////////////////////
// Setup the extended features added by DMT and then startup the original
// download manger being tweaked.
function dmtStartup()
{
  var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].
                           getService(Components.interfaces.nsIPrefService).getBranch("");
  var winType = preferencesService.getIntPref("extensions.downloadmgr.windowType");
  dmWindowType = winType;

  try {
    dmStartButtonLabel = document.getElementById("dmStartButton").label;
    dmLaunchButtonLabel = document.getElementById("dmLaunchButton").label;
    dmShowButtonLabel = document.getElementById("dmShowButton").label;
    dmCleanUpButtonLabel = document.getElementById("dmCleanUpButton").label;
    dmCleanUpSepFlex = document.getElementById("dmCleanUpSep").flex;
  } catch (e) {alert("download manager tweak Startup() failed:\n" + e.name + "\n" + e.message);}

  dmtHideByPreference();

  // Startup() is inside mozapps/content/downloads/downloads.js, the download
  // manager built into FireFox. For some reason, DMT causes it to fail by
  // trying to access window.arguments when such an attribute doesn't exist.
  // Creating the attribute, calling Statup() and then deleting the attribute
  // will cause it to run without errors.
  try {
    if (window.arguments)
      Startup();
    else
    {
      window.arguments = [0, 0];
      Startup();
      delete window.arguments;
    }
  } catch (e) {alert("download manager tweak Startup() failed:\n" + e.name + "\n" + e.message);}

  // Setup listeners so that the command/info bar can be updated.
  try {
    dmDownloadManager = document.getElementById("downloadManager");
    gDownloadsView.addEventListener("select", onDownloadSelect, false);
    dmSavedDownloadsView = gDownloadsView;
    dmDownloadManager.addEventListener("click", onDownloadClick, false);

    dmDownloadListener = new dmtDownloadProgressListener();
    gDownloadManager.addListener(dmDownloadListener);

    preferencesService.QueryInterface(Components.interfaces.nsIPrefBranch2);
    preferencesService.addObserver("extensions.downloadmgr.", dmtPrefObserver, false);
  } catch (e) {}
}


////////////////////////////////////////////////////////////////////////////////
// Cleanup the extended features added by DMT and then shutdown the original
// download manger being tweaked.
function dmtShutdown()
{
  var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].
                           getService(Components.interfaces.nsIPrefService).getBranch("");

  // Cleanup listeners.
  try {
    preferencesService.QueryInterface(Components.interfaces.nsIPrefBranch2);
    preferencesService.removeObserver("extensions.downloadmgr.", dmtPrefObserver);

    gDownloadManager.removeListener(dmDownloadListener);

    dmDownloadManager.removeEventListener("click", onDownloadClick, false);
    gDownloadsView.removeEventListener("select", onDownloadSelect, false);
    dmSavedDownloadsView.removeEventListener("select", onDownloadSelect, false);
  } catch (e) {}

  // Shutdown() is inside mozapps/content/downloads/downloads.js, the download
  // manager built into FireFox.
  Shutdown();
}

////////////////////////////////////////////////////////////////////////////////
// Utility function to generate display string from integer byte counts.
function bytesToTransfered(currBytes, maxBytes)
{
  var currBytesStr = "";
  var maxBytesStr = "";

  if (currBytes < 0)
    currBytesStr = "Unknown";
  else if (currBytes < 65536)     // 64KB
    currBytesStr = currBytes;
  else if (currBytes < 67108864)  // 64MB
    currBytesStr = parseInt(currBytes / 1024 + 0.5) + "KB";
  else
    currBytesStr = parseInt(currBytes / 1048576 + 0.5) + "MB";

  if (maxBytes < 0)               // Set to -1 if size not known yet.
    maxBytesStr = "Unknown";
  else if (maxBytes < 65536)      // 64KB
    maxBytesStr = maxBytes;
  else if (maxBytes < 67108864)   // 64MB
    maxBytesStr = parseInt(maxBytes / 1024 + 0.5) + "KB";
  else
    maxBytesStr = parseInt(maxBytes / 1048576 + 0.5) + "MB";

  return (currBytesStr + " of " + maxBytesStr);
}

////////////////////////////////////////////////////////////////////////////////
// The dmtDownloadProgressListener class is used to update the toolbar and
// infobar for downloads in progress.
// This class implements the nsIDownloadProgressListener interface.
function dmtDownloadProgressListener() {}

dmtDownloadProgressListener.prototype = {
  QueryInterface: XPCOMUtils.generateQI([Ci.nsIDownloadProgressListener]),

  onDownloadStateChange: function dlPL_onDownloadStateChange(aState, aDownload)
  {
    if (gDownloadsView.selectedItem == getDownload(aDownload.id))
    {
      // Update the entire toolbar and infobar, mainly the button greyouts.
      updateToolInfoBar(aDownload.state);
    }
  },

  onProgressChange: function(aWebProgress, aRequest, aCurSelfProgress,
                             aMaxSelfProgress, aCurTotalProgress,
                             aMaxTotalProgress, aDownload)
  {
    if (gDownloadsView.selectedItem == getDownload(aDownload.id))
    {
      var transfered = bytesToTransfered(aDownload.amountTransferred,
                                         aDownload.size);

      // Update the only progress we have, the bytes transferred.
      document.getElementById("dmDownloadTransferred").value = transfered;
      document.getElementById("dmDownloadTransferred2").value = transfered;
      document.getElementById("dmDownloadTransferredSB").value = transfered;
      document.getElementById("dmDownloadTransferredSB2").value = transfered;
    }
  },

  onStateChange: function(aWebProgress, aRequest, aState, aStatus, aDownload)
  {
  },

  onSecurityChange: function(aWebProgress, aRequest, aState, aDownload)
  {
  }
};
